function CH_JavaSettings() {
}

CH_JavaSettings.onInit = function() {
	
	//
	// build java settings list
	flow.jsettings = new Node();
	
	//
	// data connections
	//
	var item1 = new Node();	
	item1.row1 =  i18n.translate('TXT_RID_LIST_A_DATA_CONNECTIONS', 'Data Connections');
	item1.row2 = flow.selectedApp.connectionProfile == null ? i18n.translate('TXT_RID_SETTING_A_NONE', 'None') : flow.selectedApp.connectionProfile;
	flow.jsettings.append(item1);
	
	//
	// allow deletion: Only settable if the midlet is NOT preloaded
	//
	
	if (!flow.selectedApp.preloadedJava) {
		var item2 = new Node();
		item2.row1 = i18n.translate('TXT_RID_SETTING_A_ALLOW_DELETION', 'Allow Deletion');
		// Note that AllowDeletion is the OPPOSITE of protectedFromDeletion
		item2.row2 = flow.selectedApp.protectedFromDeletion ? i18n.translate('TXT_RID_SOFTKEY_NO', 'No') : i18n.translate('TXT_RID_SOFTKEY_YES', 'Yes'); 
		flow.jsettings.append(item2);
	}
		
	//
	// java permissions
	//
	var item3 = new Node();
	item3.row1 = i18n.translate('TXT_RID_HEADER_PERMISSIONS', 'Permissions');
	item3.row2 = "";
	flow.jsettings.append(item3);
}

CH_JavaSettings.onShow = function() {
	// The AllowDeletion or DataConnection dialogs may have changed the
	// settings that should now be displayed on row2. They directly 
	// update the JavaSettingsList data for row2, using flow.jsettings.
	// All we need here is to refresh the list in order to see the
	// updated values...
	view.tags.JavaSettingsList.refresh();
}

CH_JavaSettings.getSettingsURI = function(index) {

	if (index == 0 && !(flow.selectedApp.connectionSetInJAD)) {
		return "connection";
	} else if (index == 1) {
		if (flow.selectedApp.preloadedJava) {
			// For preloaded midlets, there is no "allow deletion option"
			return "permissions"
		} else {
			return "deletion";
		}
	} else if (index == 2) {
		return "permissions";
	}
}

CH_JavaSettings.onInitDataConnections = function() {
        var connecs = view.tags.DataConnectionList.data;
	view.focusedItem = connecs[0];
	var cur = flow.selectedApp.connectionProfile;
	view.selectedItems = new Node();
        for (var i=0; i<connecs.length; i++) {
		if(connecs[i].connectionName == cur) {
			view.selectedItems.append(connecs[i]);
			break;
		}
    }
}

CH_JavaSettings.setDataConnection = function(dataConnNode) {
	flow.selectedApp.connectionProfile=dataConnNode.connectionName;
	flow.jsettings[0].row2 = dataConnNode.connectionName;
}

CH_JavaSettings.onInitAllowDeletion = function() {
	view.selectedItems = new Node();
	if (flow.selectedApp.protectedFromDeletion)
	  view.selectedItems.append(view.tags.AllowDeletionList[2]);
	else
	  view.selectedItems.append(view.tags.AllowDeletionList[1]);
}

CH_JavaSettings.setAllowDeletion = function(yesno) {
	
	// _isProtected is the OPPOSITE of AllowDeletion (set by user)
	var _isProtected = (yesno == "yes") ? false: true;
	
	if (flow.selectedApp.protectedFromDeletion == _isProtected) {
		return null;
	}
	
	if (yesno == "yes") {
		flow.selectedApp.protectedFromDeletion=false;
		flow.jsettings[1].row2 = i18n.translate('TXT_RID_SOFTKEY_YES', 'Yes');
	} else if (yesno == "no") {
		flow.selectedApp.protectedFromDeletion=true;
		flow.jsettings[1].row2 = i18n.translate('TXT_RID_SOFTKEY_NO', 'No');
	}
}
