function CH_Permissions() {
}

CH_Permissions.onInit = function() {

	view.perms = flow.selectedApp.getPermissions();
	flow.permissionIndices = flow.selectedApp.getPermissionIndices();

	var pList = new Node();
	
	var item0 = new Node();
	item0.row1 = i18n.translate('TXT_RID_SETTING_A_NETWORK', 'Network');
 	item0.row2 = view.perms.Network;
 	item0.permIndex = flow.permissionIndices.Network;
	pList.append(item0);
	
	var item1 = new Node();
	item1.row1 = i18n.translate('TXT_RID_SETTING_A_MESSAGING', 'Messaging');
 	item1.row2 = view.perms.Messaging;
 	item1.permIndex = flow.permissionIndices.Messaging;
	pList.append(item1);
	
	var item2 = new Node();
	item2.row1 = i18n.translate('TXT_RID_SETTING_A_PHONE_CALLS', 'Phone Call');
 	item2.row2 = view.perms.Phone_Calls;
 	item2.permIndex = flow.permissionIndices.Phone_Calls;
	pList.append(item2);
	
	var item3 = new Node();
	item3.row1 = i18n.translate('TXT_RID_SETTING_A_APPLICATION_AUTO_START', 'App. Auto-Start');
 	item3.row2 = view.perms.Application_Auto_Start;
 	item3.permIndex = flow.permissionIndices.Application_Auto_Start;
	pList.append(item3);
	
	var item4 = new Node();
	item4.row1 = i18n.translate('TXT_RID_SETTING_A_CONNECTIVITY', 'Connectivity');
 	item4.row2 = view.perms.Connectivity;
 	item4.permIndex = flow.permissionIndices.Connectivity;
	pList.append(item4);
	
	// For untrusted midlets, "No Access" is the only option for User_Data_Read.
	// The TRS requires that in this case, the security group should be hidden.
	if (flow.selectedApp.securityDomain != "Untrusted") {
		flow.securityDomain = "Trusted";
		var item5 = new Node();
		item5.row1 = i18n.translate('TXT_RID_SETTING_A_USER_DATA_READ', 'User Data Read');
		item5.row2 = view.perms.User_Data_Read;
		item5.permIndex = flow.permissionIndices.User_Data_Read;
		pList.append(item5);
	}else{
		flow.securityDomain = "Untrusted";  //reset the value of a untrusted midlet after a trusted one
	}

	var item6 = new Node();
	item6.row1 = i18n.translate('TXT_RID_SETTING_A_USER_DATA_WRITE', 'User Data Write');
 	item6.row2 = view.perms.User_Data_Write;
 	item6.permIndex = flow.permissionIndices.User_Data_Write;
	pList.append(item6);
	
	var item7 = new Node();
	item7.row1 = i18n.translate('TXT_RID_SETTING_A_MULTIMEDIA_RECORDING', 'Multimedia Recording');
 	item7.row2 = view.perms.Multimedia_Recording;
 	item7.permIndex = flow.permissionIndices.Multimedia_Recording;
	pList.append(item7);
	
	//var item8 = new Node(); xjfh47 location based servies
	//item8.row1 = i18n.translate('TXT_RID_SETTING_A_LOCATION_BASED_SERVICES', 'Location Based Svcs');
 	//item8.row2 = view.perms.Location_Based_Services;
 	//item8.permIndex = flow.permissionIndices.Location_Based_Services;
	//pList.append(item8);
	
	view.permissionsList = pList;
 }

 CH_Permissions.onShow = function() {
	view.perms = flow.selectedApp.getPermissions();
	// Explicitly refresh the values in the list, to show updates from MM_SettingsPermission 
 	view.permissionsList[0].row2 = view.perms.Network;
 	view.permissionsList[1].row2 = view.perms.Messaging;
 	view.permissionsList[2].row2 = view.perms.Phone_Calls;
 	view.permissionsList[3].row2 = view.perms.Application_Auto_Start;
 	view.permissionsList[4].row2 = view.perms.Connectivity;
	var i = 5;
	if (flow.securityDomain == "Trusted") {
		view.permissionsList[i].row2 = view.perms.User_Data_Read;
		i++;
	} 
	view.permissionsList[i+0].row2 = view.perms.User_Data_Write;
	view.permissionsList[i+1].row2 = view.perms.Multimedia_Recording;
	//view.permissionsList[i+2].row2 = view.perms.Location_Based_Services;
	
	view.tags.PermissionsList.refresh();
}

CH_Permissions.selectPermission = function(permission) {

	flow.selectedPermName = permission.row1;
	// The selectedPermName may have spaces in it, so we cannot use it to
	// access the value from view.perms. Use the corresponding index instead.
	flow.selectedPermIndex = permission.permIndex;
        var fullaccess = new String(i18n.translate('TXT_RID_SETTING_B_FULL_ACCESS', 'Full Access'));
	var perm = new String(flow.selectedApp.getPolicyName(flow.selectedPermIndex));

	if (perm.toString() != fullaccess.toString()) {
		flow.javasettingsPermission = permission;
		return "editPerm";
	} else {
		// notify that selected permission app is read only
		flow.infoMessageTitle = flow.selectedApp.appName;
		flow.infoMessage = i18n.translate('FMT_RID_INSTRUCTIONALTXT_1_HAS_FULL_ACCESS_TO', 
										  '%1 has full access to: ').arg(flow.selectedApp.appName) + flow.selectedPermName;
		return "fullAccessNotice";
	}
}
