function CH_JavaSettingsPermission() {
}

CH_JavaSettingsPermission.onInit = function() {

	println("Started CH_JavaSettingsPermission.onInit ");
	view.settingsList = new Node();
	var availablePerms = flow.selectedApp.getAvailablePermissions(flow.selectedPermIndex);

	var item0 = new Node();
	item0.label = i18n.translate('TXT_RID_SETTING_B_ALWAYS_ASK', 'Always Ask');
	println("availablePerms[AlwaysAsk] is " + availablePerms["AlwaysAsk"]);
	if (availablePerms["AlwaysAsk"] == "enable") {
		item0.enabled = "true";
	} else {
		item0.enabled = "false";
	}
	view.settingsList.append(item0);

	var item1 = new Node();
	item1.label = i18n.translate('TXT_RID_SETTING_B_ASK_ONCE_PER_APPLICATION', 'Ask Once Per Application');
	println("availablePerms[AskOncePerApplication] is " + availablePerms["AskOncePerApplication"]);
	if (availablePerms["AskOncePerApplication"] == "enable") {
		item1.enabled = "true";
	} else {
		item1.enabled = "false";
	}
	view.settingsList.append(item1);

	var item2 = new Node();
	item2.label = i18n.translate('TXT_RID_SETTING_B_NEVER_ASK', 'Never Ask');
	println("availablePerms[NeverAsk] is " + availablePerms["NeverAsk"]);
	if (availablePerms["NeverAsk"] == "enable") {
		item2.enabled = "true";
	} else {
		item2.enabled = "false";
	}
	view.settingsList.append(item2);

	var item3 = new Node();
	item3.label = i18n.translate('TXT_RID_SETTING_B_NO_ACCESS', 'No Access');
	println("availablePerms[No Access] is " + availablePerms["NoAccess"]);
	if (availablePerms["NoAccess"] == "enable") {
		item3.enabled = "true";
	} else {
		item3.enabled = "false";
	}
	view.settingsList.append(item3);

	view.selectedItems = new Node();
	view.selectedItems.append(new Node());
	this.updateSelection();
}

CH_JavaSettingsPermission.onShow = function() {
	
	this.updateSelection();
	view.tags.SettingsPermList.refresh();
}

CH_JavaSettingsPermission.updateSelection = function() {

	var permPolicy = flow.selectedApp.getPermissionPolicy(flow.selectedPermIndex);
	var permIndex = this.indexForPolicy(permPolicy);
	
	view.tags.SettingsPermList.focusedItem = view.settingsList[permIndex];
	view.selectedItems.remove(view.selectedItems[0]);
	view.selectedItems.append(view.settingsList[permIndex]);

	// Keep index of current setting for later use in HigherRisk.xml view etc
	flow.currentPermPolicy =  permPolicy;
}

// setPermission puts the platform in sync with the UI
CH_JavaSettingsPermission.setPermission = function (permIndex) {
	
	if (view.tags.SettingsPermList.focusedItem.enabled == "false") {
		println("\n>>>>>>>>> This policy is disabled for this midlet <<<<<<<<<<\n");
		return "DISABLED"; 
	} else 	if (permIndex == this.indexForPolicy(flow.currentPermPolicy)) {
		// Return to Permissions screen without change...
		return "OK";
	} else {
		flow.newPermPolicy = this.policyForIndex(permIndex);
		return(flow.selectedApp.setPermissionPolicy(flow.selectedPermIndex, 
													flow.currentPermPolicy, 
													flow.newPermPolicy));
	}
}


// The constants corresponding to the permissions policies are defined in
// J2ME_JAID_APIs.h on the platform.  The order of the options on the
// screen is defined by the CUIS. Here we map from one to the other.
// Keeping this mapping here allows the order of the options
// to be easily changed in the MAML files. This would for example make
// it easy for the options to be re-arranged in order of increasing 
// risk (i.e. with "No Access" first, then "Always Ask", etc.)
CH_JavaSettingsPermission.policyForIndex = function(index) 
{
	switch (index) {
		case 0:
		return 1;
		case 1:
		return 0;
		case 2:
		return 2;
		case 3:
		return 3;
	}		
}

CH_JavaSettingsPermission.indexForPolicy = function(policy) 
{
	switch (policy) {
		case 0:
		return 1;
		case 1:
		return 0;
		case 2:
		return 2;
		case 3:
		return 3;
	}		
}

// If the user agrees to a higher risk setting, set the new policy without checking.
// Checking in the datamodel's setPermissionPolicy is skipped by specifying the 
// "old" policy (2nd arg) as being the same as the new policy (3rd arg)

CH_JavaSettingsPermission.setPermissionPolicy = function() 
{
	var appNode = eval(flow.selectedApp);
	appNode.setPermissionPolicy(flow.selectedPermIndex, flow.newPermPolicy, flow.newPermPolicy);
}
