function CH_MoveToFolder() {
}

CH_MoveToFolder.onInit = function() {
	initMidletEnabledFolders();
	view.focusedItem = view.tags.MoveToFolderList.data[0];
}

CH_MoveToFolder.moveToFolder = function(appNode, destFolder) {
	flow.destinationFolder = findMMFolderNode(destFolder.uid, destFolder.appName);
	// Move the midlet to the last item of the folder
	// according to the CUIS.
	return appNode.moveToFolder(flow.destinationFolder) ? "true" : "false";
}

CH_MoveToFolder.refreshFromFolder = function() {

	// if app was successfully moved out of 'from' folder, you'll need to refresh
	if (flow.fromFolderTagToRefresh) {
		flow.fromFolderTagToRefresh.reload();
		flow.fromFolderTagToRefresh = null;
	}
}

/**
 * Create a tree copy of all mainmenu folders except for settings
 */
function initMidletEnabledFolders() {

	view.mmfolders = new Node();

	var settings = i18n.translate('TXT_RID_GRID_ITEM_SETTINGS', 'Settings');
	// no recursion needed as we only can display 2 levels of folders
	for (i = 0; i < mainmenu.ALL.length; i++) {

		// first level folders
		if (mainmenu.ALL[i].midletEnabled) {

			// don't include 'Settings' folder
			if (mainmenu.ALL[i].appName == settings) {
				continue;
			}

			var folder = new Node();
			folder.label = mainmenu.ALL[i].appName;
			folder.uid = mainmenu.ALL[i].uid;
			folder.appName = mainmenu.ALL[i].appName;
			folder.icon = mainmenu.ALL[i].LJbigIcon;
			view.mmfolders.append(folder);

			// second level folders
			var appNode = mainmenu.ALL[i];
			appNode.ALL; // mainmenu datamodel requirement

			for (j = 0; j < appNode.length; j++) {
				if (appNode[j] != null) {
					if (appNode[j].midletEnabled) {
						var folder2 = new Node();
						folder2.label = appNode[j].appName;
						folder2.uid = appNode[j].uid;
						folder2.appName = appNode[j].appName;
						folder.append(folder2);
					}
				}
			}
		}
	}
}

/**
 * figure out real destination FolderNode from mainmenu datamodel.  
 * TODO: hack + inefficient.  need a datamodel API for this
 */
function findMMFolderNode(uid, appName) {
	for (i = 0; i < mainmenu.ALL.length; i++) {

		// first level folders
		if (mainmenu.ALL[i].folder && mainmenu.ALL[i].uid==uid && mainmenu.ALL[i].appName==appName) {
			flow.destFolderNavLevel = 1;
			return mainmenu.ALL[i];
		}

		var appNode = mainmenu.ALL[i];
		appNode.ALL; // mainmenu datamodel requirement
		for (j = 0; j < appNode.length; j++) {
			if (appNode[j] != null) {
				if (appNode[j].folder && appNode[j].uid==uid && appNode[j].appName==appName) {
					flow.destFolderNavLevel = 2;
					return appNode[j];
				}
			}
		}
	}
	return null;
}
