function CH_MainMenu_Reorder() {

}

CH_MainMenu_Reorder.onInit = function() {
	// label of left soft key
	document.getElementById("menu_grab").label = i18n.translate('TXT_RID_OPTION_GRAB', 'Grab');

	// whether 'submit' menu is visible
	view.isSubmitVisible = "false";
	
	// define 3 action modes:
	//   0 - uninitialized
	//   1 - selecting a target item
	//   2 - moving/shifting the target item
	// TODO: the JS engine seems to have problem, set mode as true/false will cause problem. true will be changed to false after awhile.
	view.isShiftingMode = 0;

	view.i_prevFocus = 0;
	view.i_currentFocus = 0;	

	if (flow.reorderList == null) {
		flow.reorderList = mainmenu.ALL;
	}
	
	for (i=0; i<flow.reorderList.length; i++) {
		if (flow.focusedItem.equals(flow.reorderList[i])){
			view.i_currentFocus = i;
			view.i_prevFocus = i;
			break;
		}
	}
	// set current focus	
	view.tags.MainMenuReorderList.focusedItem = flow.focusedItem;

	// copy items in flow.reorderList to a temp list.  This will be used as a JS data source.
	view.reorderListCopy = new Node();	
    for (i = 0; i < flow.reorderList.length; i++) {    	
		view.reorderListCopy.append(flow.reorderList[i]);
    }
    
    var viewType = mainmenu.view;
	if ( flow.folderNavLevel == 0) {
		if (viewType == "grid")
			view.tags.MainMenuReorderList['class'] = 'reorderGridclass';
		else if (viewType == "list")
			view.tags.MainMenuReorderList['class'] = 'reorderIconListclass';
		else
			view.tags.MainMenuReorderList['class'] = 'reorderSpinnerclass';
	} else {
		view.tags.MainMenuReorderList['class'] = 'reorderListclass';
	}
}

CH_MainMenu_Reorder.onFocus = function() {

	if (!view.tags.MainMenuReorderList.focusedItem) return;
		
	// find the index of focused item
	for (i=0; i<view.reorderListCopy.length; i++) {
		if (view.tags.MainMenuReorderList.focusedItem.equals(view.reorderListCopy[i])) {
			view.i_currentFocus = i;
			break;
		}
	}

	// if not the very first time, then swap the 2 items.
	if(view.i_prevFocus != view.i_currentFocus) {
		if ( view.isShiftingMode == 2 ) {
			var tmp = view.reorderListCopy[view.i_prevFocus];
			view.reorderListCopy[view.i_prevFocus] = view.reorderListCopy[view.i_currentFocus];
			view.reorderListCopy[view.i_currentFocus] = tmp;
			view.i_prevFocus = view.i_currentFocus;
			view.tags.MainMenuReorderList.focusedItem = tmp;
			view.tags.MainMenuReorderList.refresh();
		} else if (view.isShiftingMode == 1) {
			view.i_prevFocus = view.i_currentFocus;
	        }
	}

	// let the caller view know what the focus should be now
   	flow.focusedItem = view.tags.MainMenuReorderList.focusedItem;
}

CH_MainMenu_Reorder.onSelect = function() {
	if (view.isShiftingMode <= 1) {
		if (view.isShiftingMode == 0) {
			view.i_prevFocus = view.i_currentFocus;
		}
		view.isShiftingMode = 2;
		document.getElementById("menu_grab").label = i18n.translate('TXT_RID_OPTION_INSERT', 'Insert');
		view.tags.refreshSoftkeys();
	} else {
		view.isShiftingMode = 1;
		document.getElementById("menu_grab").label = i18n.translate('TXT_RID_OPTION_GRAB', 'Grab');
		view.tags.refreshSoftkeys();

		CH_MainMenu_Reorder.submit();	  // in order to compliant with specs, submit every time 'insert' is selected

		view.tags.MainMenuReorderList.focusedIndex = view.i_currentFocus;
		view.tags.MainMenuReorderList.focusedItem = view.reorderListCopy[view.i_currentFocus];
		view.tags.MainMenuReorderList.refresh();
	}

	// let the caller view know what the focus should be now
	//flow.focusedItem = view.tags.MainMenuReorderList.focusedItem;

	
	// callback to svg if there is one
	if(view.reorderListener) {
		view.reorderListener.update(view.i_currentFocus);
	}
}


/** 
 * submit changes to system registry, and update main menu
 */
CH_MainMenu_Reorder.submit = function() {

	// special datamodel case for mainmenu root node
	if (flow.reorderList == mainmenu.ALL) { 		
		mainmenu.reorder(view.reorderListCopy);
		view.reorderList = mainmenu.ALL;
	}
	else { // folder node
		flow.reorderList.reorder(view.reorderListCopy);
	}
	// let the caller view know what the focus should be now
	flow.focusedItem = view.tags.MainMenuReorderList.focusedItem;
}


CH_MainMenu_Reorder.onBack = function() {
	// libmm90399 - this fixes the focusedItem in the previous view.
	// It also puts the focus on the same item which was focused in the reorder screen
	flow.reorderTagToRefresh.focusedIndex = view.tags.MainMenuReorderList.focusedIndex;
	flow.reorderTagToRefresh.refresh();
}


