function CH_ViewDetails(){
}

CH_ViewDetails.onInit = function() {
	view.mAppProps = flow.selectedApp.appProperties;
	buildCertificateTab();
	if(view.mAppProps.drm.isProtected)
		buildRightsTab();
}

function buildCertificateTab() {

	view.certificate = new Node();

	if(!view.mAppProps.cert.hasCertificate)
	{
		var noCertNode = new Node();
		noCertNode.label = i18n.translate('TXT_RID_STANDARD_NO_CERTIFICATE_EXISTS', 'No certificate exists.');
		noCertNode.value = "";
		view.certificate.append(noCertNode);
	}
	else
	{
		var signerNode = new Node();
		signerNode.label = i18n.translate('TXT_RID_STANDARD_SIGNER_COLON', 'Signer:');
		signerNode.value = view.mAppProps.cert.signer;
		view.certificate.append(signerNode);
		
		var vendorNode = new Node();
		vendorNode.label = i18n.translate('TXT_RID_STANDARD_VENDOR_COLON', 'Vendor:');
		vendorNode.value = view.mAppProps.cert.vendor;
		view.certificate.append(vendorNode);
		
		var countryNode = new Node();
		countryNode.label = i18n.translate('TXT_RID_STANDARD_COUNTRY_COLON', 'Country:');
		countryNode.value = view.mAppProps.cert.country;
		view.certificate.append(countryNode);
		
		var orgNode = new Node();
		orgNode.label = i18n.translate('TXT_RID_STANDARD_ORGANIZATION_COLON', 'Organization:');
		orgNode.value = view.mAppProps.cert.organization;
		view.certificate.append(orgNode);
		
		var serialNode = new Node();
		serialNode.label = i18n.translate('TXT_RID_STANDARD_SERIAL_NUMBER_COLON', 'Serial Number:');
		serialNode.value = view.mAppProps.cert.serialNumber;
		view.certificate.append(serialNode);
	}
}

function buildRightsTab() {

	view.drm_rights = new Node();
	
	var licenseNode = new Node();
	if(view.mAppProps.drm.license == "combinedDelivery")
		licenseNode.label = i18n.translate('TXT_RID_STANDARD_YOU_DO_NOT_HAVE_A_LICENSE_TO_USE_THIS_FILE', 
										   'You do not have a license to use this file.');
	else if(view.mAppProps.drm.license == "singleDelivery")
		licenseNode.label = i18n.translate('TXT_RID_STANDARD_YOU_DO_NOT_HAVE_A_LICENSE_TO_USE_THIS_FILE_TO_PURCHASE_ONE_SELECT_OPTIONS', 
										   'You do not have a license to use this file. To purchase one select Options.');
	else if(view.mAppProps.drm.license == "forwardLocked")
		licenseNode.label = i18n.translate('TXT_RID_STANDARD_NO_LICENSE_IS_REQUIRED_TO_USE_THIS_FILE', 
										   'No license is required to use this file.');
	else
		licenseNode.label = i18n.translate('TXT_RID_EMPHASIS_EXECUTE_LICENSE', 'Execute License:');
	licenseNode.value = "";
	view.drm_rights.append(licenseNode);
	
	for(i = 0; i < view.mAppProps.drm.rights.length; i++)
	{
		var numConstraints = view.mAppProps.drm.rights[i].numConstraints;
		for(j = 0; j < numConstraints; j++)
		{
			var usageNode = new Node();
			usageNode.label = i18n.translate('TXT_RID_EMPHASIS_USAGE', 'Usage:');
			usageNode.value = view.mAppProps.drm.rights[i].getConstraint(j);
			view.drm_rights.append(usageNode);
		}
		
		var issuerNode = new Node();
		issuerNode.label = i18n.translate('TXT_RID_STANDARD_RIGHTS_ISSUER_COLON', 'Rights Issuer:')
		issuerNode.value = view.mAppProps.drm.rights[i].issuer;
		view.drm_rights.append(issuerNode);

		var separator = new Node();
		separator.label = "----------------------------------------";
		separator.value = "";
		view.drm_rights.append(separator);
	}	
}

